/***********************************************************
Experiment 07: Using a Stepper Motor
Description: You can observe the stepper motor is fast and forward in a circle, next the stepper motor is 
             slow and reverse in a circle.
Source: Texoham Centre for Advanced Computing
Website: www.texoham.com
***********************************************************/
int IN1 = 11;               //definition digital 11th pin as pin to control the IN1 (ULN24L01)
int IN2 = 10;               //definition digital 10th pin as pin to control the IN2 (ULN24L01)
int IN3 = 9;                //definition digital 9th pin as pin to control the IN3 (ULN24L01)
int IN4 = 8;                //definition digital 8th pin as pin to control the IN4 (ULN24L01)

int _step = 512; 
int _speed = 100; 
void setup()
{
 pinMode(IN1, OUTPUT);       //Set digital 11th port mode, the OUTPUT for the output
 pinMode(IN2, OUTPUT);       //Set digital 10th port mode, the OUTPUT for the output
 pinMode(IN3, OUTPUT);       //Set digital 9th port mode, the OUTPUT for the output
 pinMode(IN4, OUTPUT);       //Set digital 8th port mode, the OUTPUT for the output
}

void loop()
{
  Speed(15);                  //Stepper motor speed = 15 fast (note:speed from 1 to 15)
  Step(512);                  //Stepper motor forward 512 steps ---- 360 angle    
  delay(2000);                // delay 2Sec
  Speed(15);                  //Stepper motor speed = 1 slow  (note:speed from 1 to 15)
  Step(-512);                 //Stepper motor backward 512 steps ---- 360 angle    
  delay(2000);                //delay 2Sec
}
void Speed(int stepperspeed)  //set Stepper speed 
{
    _speed = 15 - stepperspeed;
    if( _speed<1)
    {
     _speed = 1;
    }
    if( _speed>15)
    {
     _speed = 15;
    }
}
void Step(int _step)          //Stepper motor rotation
{
  if(_step>=0)
  {                           // Stepper motor forward
    for(int i=0;i<_step;i++)
    {   
      setStep(1, 0, 0, 1);
      delay(_speed); 
      setStep(1, 0, 0, 0);
      delay(_speed);
      setStep(1, 1, 0, 0);
      delay(_speed);
      setStep(0, 1, 0, 0);
      delay(_speed);
      setStep(0, 1, 1, 0);
      delay(_speed);
      setStep(0, 0, 1, 0);
      delay(_speed);
      setStep(0, 0, 1, 1);
      delay(_speed); 
      setStep(0, 0, 0, 1);
      delay(_speed);
    }
  }
  else
  {                                // Stepper motor backward
     for(int i=_step;i<0;i++)
     {  
      setStep(0, 0, 0, 1);
      delay(_speed);
      setStep(0, 0, 1, 1);
      delay(_speed);
      setStep(0, 0, 1, 0);
      delay(_speed);
      setStep(0, 1, 1, 0);
      delay(_speed);
      setStep(0, 1, 0, 0);
      delay(_speed);
      setStep(1, 1, 0, 0);
      delay(_speed);
      setStep(1, 0, 0, 0);
      delay(_speed);
      setStep(1, 0, 0, 1);
      delay(_speed);
    }
   }
}
void setStep(int a, int b, int c, int d)  
{  
    digitalWrite(IN1, a);     
    digitalWrite(IN2, b);     
    digitalWrite(IN3, c);     
    digitalWrite(IN4, d);     
}  
