/***********************************************************
Experiment 12: Ir Receiver and Controller
Description: LCD1602 display's a Unique code when pressing each button on Remote
Source: Texoham Centre for Advanced Computing
Website: www.texoham.com
***********************************************************
NOTE: NEED IR Remote libraries for this code to work. 
***********************************************************
*/

#include <IRremote.h>
#include <LiquidCrystal.h>
 
LiquidCrystal lcd(4, 6, 10, 11, 12, 13);
int RECV_PIN = 3;
IRrecv irrecv(RECV_PIN);
decode_results results;

void setup()
{
  irrecv.enableIRIn(); 
  lcd.begin(16, 2);
}
 
void loop() 
{
  if (irrecv.decode(&results)) 
  {
    lcd.setCursor(0,0);
    lcd.clear();
    lcd.print("IR Remote Code");
    lcd.setCursor(0,1);
    lcd.print("Code : ");
    lcd.print(results.value);
    irrecv.resume();                            // Receive the next value
  }
  delay(100);
}
