/***********************************************************
PROJECT 02:   Obstacle Avoidance Car
Description: An obstacle avoiding robot is a fully autonomous robot which can avoid any obstacle it encounters.
             When it encounters an obstacle it automatically
             stops moving forward and makes a left or right turn.
Company: Texoham Centre for Advanced Computing
Website: www.texoham.com
***********************************************************/

const int trigPin = 10;               //arduino 10th pin connected to trig Pin of the ultrasonic sensor
const int echoPin = 11;               //arduino 11th pin connected to echo Pin of the ultrasonic sensor

const int Input1 = 3;                 //arduino 3rd pin connected to L293D pin input1
const int Input2 = 4;                 //arduino 4th pin connected to L293D pin input2
const int Input3 = 8;                 //arduino 8th pin connected to L293D pin input3
const int Input4 = 9;                 //arduino 9th pin connected to L293D pin input4


void setup() 
{
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode (Input1, OUTPUT);        
  pinMode (Input2, OUTPUT);
  pinMode (Input3, OUTPUT);
  pinMode (Input4, OUTPUT);
}
long duration, distance;

void loop()
{     
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);  
  duration = pulseIn(echoPin, HIGH);
  distance = duration/58.2;
  if(distance<30)
                                       // The speed of sound is 340 m/s or 29 microseconds per centimeter. 
                                       // The echo travels out and back, so to find the distance of the 
                                       // object we take half of the distance travelled. 
   //return microseconds / 29 / 2; 
  {
    digitalWrite(Input1, HIGH); 
    digitalWrite(Input2, LOW); 
    digitalWrite(Input3, LOW); 
    digitalWrite(Input4, HIGH);
    delay(1000);
  }
  else
  {
    digitalWrite(Input1, HIGH); 
    digitalWrite(Input2, LOW); 
    digitalWrite(Input3, HIGH); 
    digitalWrite(Input4, LOW);
  }  
  delay(0);
}
